#ifndef _AL0GATESINTERNAL_H
#define _AL0GATESINTERNAL_H

#include "gatesConstants.h"
#include "shadowIDT.h"
#ifdef USERGEN
#include <linux/genetlink.h> 
#include <linux/netlink.h>

#define GENLMSG_DATA(glh) ((void *)(NLMSG_DATA(glh) + GENL_HDRLEN))
#define GENLMSG_PAYLOAD(glh) (NLMSG_PAYLOAD(glh, 0) - GENL_HDRLEN)
#define NLA_DATA(na) ((void *)((char*)(na) + NLA_HDRLEN))
#define NLA_PAYLOAD(len) (len - NLA_HDRLEN)
uint32_t generate_local_port(void);
int create_nl_socket(int protocol, int groups, int pid);
int sendto_fd(int s, const char *buf, int bufLen);
int get_family_id(int sd, char * family);
#endif


struct notifThreadArg {
	struct anaEventNotif_s *notif;
	eventHandler_t handler;
};


int setSockOptWrapper(void *sock, int level,int op, char * optval, int optlen);
int readWrapper(void *sock, char * data, int len);
int sendControl(struct anaMinmexSpecs_s * spec, void *msg, int len);
int recvControl(struct anaMinmexSpecs_s * spec, void *buffer);
int sendData(struct anaMinmexSpecs_s * spec, void *msg, int len);
int bindWrapper (void *sock, struct sockaddr * address, int size);
void anaL0_launchThread(char *data, int len, anaLabel_t input, void *aux); 			   
void handleHbeat(char *data, int len, anaLabel_t input, void *aux);
void notifWrapper(void *data, int len, anaLabel_t input, void *aux);
void * anaL0_copyAux(void * aux, copyAuxFunction copyAux, freeAuxFunction freeAux, anaCallback_t fct);
void anaL0_freeAux(void * aux);
int threadNotification(struct notifThreadArg *notifArg);

#endif
