#ifndef _SHADOWIDT_H
#define _SHADOWIDT_H

#include "anaCommon.h"


struct SDTentry_s {
	anaLabel_t label;             /*  key of the hash table 		*/
	anaCallback_t callBackFct;   /* value to be looked for 		 	*/
	copyAuxFunction copyAux;
	freeAuxFunction freeAux;
	void *aux;			/* auxiliary argument to callBack function */
	struct SDTentry_s *next;    /* in case there is a hash conflict */
};

struct shadowIDT_s{
	unsigned int size;  			/* length of the entries array 	*/
	int hashMaskSize;			/* size of the hash mask, is log2 of table size*/
	struct SDTentry_s **tab;	/* table holding the entries 	*/
	
} ;  

int label2hash(struct shadowIDT_s *SDT, anaLabel_t l);

int initializeSDT(struct shadowIDT_s *SDT, int bitSize);

struct SDTentry_s* getSDTEntry(struct shadowIDT_s *SDT, anaLabel_t l);

int freeSDTTable(struct shadowIDT_s *SDT);

int freeSDTEntry(struct shadowIDT_s *SDT, anaLabel_t l);

int addSDTEntry(struct shadowIDT_s *SDT, struct SDTentry_s *toAdd);


#endif
