#ifndef _MQUEUET_H
#define _MQUEUET_H

#include "anaCommon.h"
#include "analock.h"


struct MessageQueue_s {
	void *message;
	int msgLen;
	struct MessageQueue_s *next;	
};




struct MQEntry_s {
	anaLabel_t label;             /*  key of the hash table  */
	analock_cond_t cond;
	analock_t condLock;
	analock_t queueLock;
	struct MessageQueue_s *queue;
	struct MQEntry_s *next;    /* in case there is a hash conflict */
};


struct MQTable_s{
	unsigned int size;  			/* length of the entries array 	*/
	int hashMaskSize;			/* size of the hash mask, is log2 of table size*/
	struct MQEntry_s **tab;			/* table holding the entries 	*/
	
} ;


#include "messageQueue_decl.h"

#endif /* _MQUEUET_H */
