
#include <regex.h>
#include "anaLib2.h"

/* Data structures */

struct regexp_entry {

	/* an entry in the regexp "routing table" */

	anaLabel_t idp;   /* the publisher */
	char *regexp_str; /* the text regexp */
	regex_t regex;    /* the compiled regexp */
	char flags;       /* various flags */
	uint16_t hops;    /* distance in overlay */
	struct regexp_entry *next;
};

struct cpmt_entry {

	/* a compartment this brick is using */
	/* for future use */

	anaLabel_t idp;   /* the CPE */
	struct context_s ctx;
	struct service_s srv;
	struct cpmt_entry *next;
};

/* Function prototypes */

void recv_msg(struct anaL2_message *msg);
void handle_resolve(struct anaL2_message *msg);
void handle_publish(struct anaL2_message *msg);
void handle_unpublish(struct anaL2_message *msg);

int add_entry(char *regexp_str, anaLabel_t idp, char flags, uint16_t hops);
int del_entry(char *regexp_str, anaLabel_t idp);
struct regexp_entry* lookup_entry(char *str);
void free_entry(struct regexp_entry *reg);

/* Global variables */

extern struct regexp_entry *regexp_table;
extern struct cpmt_entry *cpmt_list;

/* flags: 8 bits field */

#define REGEXP_SCOPE_LOCAL 0x01
#define REGEXP_SCOPE_GLOBAL 0x02
#define REGEXP_CIRCUIT_SET 0x04
