/* header file for the ANA Demo Chat Application
 *
 * Initializes the textual user interface. Server and port are
 * displayed in the connection information.
 */ 
void init_tui();

/*
 * Closes the textual user interface.
 */
void close_tui();

/*
 * Refreshes the user interface.
 */
void refresh_tui();

/*
 * Clears the input window. Call this wenn a message has been sent.
 */
void reset_input_win();

/*
 * Posts a message to the message board. Usually this is done for
 * all incoming message from the server.
 */
void post_bold_message(char *msg); /* post in bold character */

void post_message(char *msg);
/*
 * Display a character in the input window.
 */
void echo_character(char c);

/*
 * Delete last char from the input window
 */
void del_char();

