#ifndef _ATTACHEDT_H
#define _ATTACHEDT_H

#include "anaCommon.h"


struct attachedBrick_s {
	
	anaHandle_t handle;  /*  key of the hash table, identifier of the brick */
	
	int dataMode;
	int dataDescriptor;   	/* must be value specicied in anaTypes.h*/
	struct socket * dataSocket;
	void *dataAux;			/* complementary argument depending on the mode*/
	 					 	/* e.g for UDP this would be a sockaddr_in */
	int controlMode;					 
	int controlDescriptor;
	struct socket * controlSocket;
	void *controlAux;
	
	anaLabel_t notifLabel;
	
	struct attachedBrick_s *next;	
};



struct attachedTable_s{
	unsigned int size;  			/* length of the entries array 	*/
	int hashMaskSize;			/* size of the hash mask, is log2 of table size*/
	int nbAttached;
	struct  attachedBrick_s**tab;			/* table holding the entries 	*/
	
} ;



int initializeATTT (struct attachedTable_s *table, int hashMaskSize);
struct attachedBrick_s* gettableEntry(struct attachedTable_s *table, anaHandle_t h);
int freetable(struct attachedTable_s *table);
int freetableEntry(struct attachedTable_s *table, anaHandle_t h);
int addtableEntry (struct attachedTable_s *table, struct attachedBrick_s *toAdd);



#endif
