#ifndef _GATESPLUG_H
#define _GATESPLUG_H

#include "anaCommon.h"
#ifdef USER
#include <sys/select.h>
#include <signal.h>
#include <pthread.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <stdio.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <errno.h>
#include <poll.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <asm/types.h>
#include <sys/un.h>
#endif /*USER*/

#ifdef KERNEL
#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,19)
#include <net/genetlink.h>
#endif
#endif /*KERNEL*/

#include "attachedTable.h"

#include "gatesConstants.h"

struct commGate_s {
	int mode;
	int descriptor;
        struct socket * commGateSocket;
        char *urn;
	struct commGate_s *next;
}; 

struct notifAuxGates {
	anaHandle_t handle;	
	anaLabel_t notifLabel;	
	void *handlerPointer;
	int threadFlag;
};

/* contains  all data gates open by this plugin */
struct commGate_s *defaultDataGate;
/* contains all control gates open by this plugin */
struct commGate_s *defaultControlGate;

struct attachedTable_s attBricksTable;


int relayAttach(char *msg, int length);
int relayControl(anaHandle_t handle, void *msg, int len);
void relayData(char *data, int len, anaLabel_t input,  anaHandle_t *h);
void relayDetach(char *msg, int length);
void relayRegister(char *msg, int len);
void relayRedirect(char *msg, int len);
void relayHBRequest(char *msg, int length);
void relayUnregister(char * msg, int len);
void relayChangeView(char * msg, int len);
void relayForkData(char * msg, int len);

int addDataGate(struct commGate_s *gate);
int addControlGate(struct commGate_s *gate);

#ifdef KERNEL
int sendGenetlink(int desc, void *msg, int len, int command);

#endif

#endif
