#!/bin/sh

# shell script to start ana with ip compartment (single interface)
#
# use:
#
# ./start_anaip.sh {vlinkID} {interface} {ip address of node} {default gateway}
  
if [ $# -ne 5 ]; then
	echo 1>&2 Usage: $0 {vlinkID} {interface} {ip address of node} {netmask} {default gateway}
	exit 127
fi

insmod modules/anaControl.ko 
insmod modules/anaMinmex.ko
insmod modules/anaVlink.ko  
./bin/vlconfig create $1
./bin/vlconfig add_if vlink1 $2
./bin/vlconfig up vlink1
sleep 1
insmod modules/eth-vl1.ko
sleep 1
insmod modules/ip_main.ko 
insmod modules/ip_forward.ko 
insmod modules/ip_checksum.ko 
sleep 1
insmod modules/anaGates.ko a=c_genetlink://ANA,d_genetlink://ANA
sleep 1
./bin/ip_cfg -n genetlink://ANA -d genetlink://ANA -c genetlink://ANA -i $3 -m $4 -e eth01 &
sleep 1
./bin/ip_cfg -n genetlink://ANA -d genetlink://ANA -c genetlink://ANA -g $5 &
sleep 1
insmod modules/ip_routing.ko
