	/* C/bricks/examples/templates/brickAL2_template.c
 * 
 * template file which shows use of API Level 0
 *
 * Author: Ghazi Bouabene <ghazi.bouabene@unibas.ch> 
 * 	   Christophe Jelger <christophe.jelger@unibas.ch> 
 * 	   Theus Hossmann <hossmann@tik.ee.ethz.ch> 
 * 	   Ariane Keller <ariane.keller@tik.ee.ethz.ch>
 * 	   	
 * Copyright (c) 2008, Ghazi Bouabene, University of Basel
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 *
 */

/*--------------------------- Default brick header code -------------------------------*/

/* !!! Your code MUST always provide both the brick_start and brick_exit functions !!! */

/* Update the fields below with your own name + MINMEX-brick gates specifications */

#ifdef KERNEL
#include <linux/module.h>
MODULE_LICENSE("Dual BSD/GPL");
MODULE_AUTHOR("Ghazi Bouabene");
static char *cd = "kern://brickc1"; //"udp://127.0.0.1:5559"; /* brick data url*/
static char *cc = "kern://brickd1"; //"udp://127.0.0.1:8889"; /* brick control url*/
static char *nc = "kern://anaMinmex"; //"udp://127.0.0.1:6666"; /* minmex control url*/
static char * debug  = "ANA_DEBUG";
#endif /* KERNEL */

/* !!! Change the two variables below to the name of your brick !!! */
#define MODULE_NAME brick1
char mymodename[]="quickRepUser";

#include "anaLib2.h"
//#include "anaError.h"

anaLabel_t ethIDP;
anaLabel_t serviceIDP;

#include "brick_template.h"
#include "quickRepository.h"

/*-------------------------------------------------------------------------------------*/

void brick_exit() {

	anaPrint(ANA_DEBUG, "Brick EXIT\n");
}

int brick_start() {
/* first we initialiize our quickrep */
	int ret;
	struct QREP rep;
	struct QREPEntry *entry = NULL;

	struct QREPKeyObjectList *res = NULL;
	
	char *value = "bidon";
	
	memset(&rep, 0, sizeof(struct QREP));
		
	ret =  initQRepository(&rep, 10, 6);
	if(ret<0){
		anaPrint(ANA_DEBUG, "init failed\n");
		return 1;
	}
	/* we add an entry */
	
	entry = allocateQREPEntry("nom", 4 , value, 6);
	
	/* we add key words to it*/
	ret =  QREPaddKeywordToEntry(entry, "chatter");
	if (ret<0){
		anaPrint(ANA_DEBUG, "adding key failed\n");
		return 1;
	}
	/* we add it to the repository */
	ret = addQREPEntry(&rep, entry);
	
	if (ret<0){
		anaPrint(ANA_DEBUG, "adding entry failed\n");
		return 1;
	}
	/* we look it up */
	ret = QREPfindByQuery(&rep, "chatter", &res);
	if(ret<0){
		anaPrint(ANA_DEBUG, "lookup failed failed\n");
		return 1;
	}
	
	
	
	anaPrint(ANA_DEBUG, "entry's name: %s\n", (char *)(res->entry->name));
	QREPfreeQueryRes(res);
	freeQRepository(&rep, (freeValFunction_t) free);
	return 0;	
}
