#ifndef _ANA_AL1_H
#define _ANA_AL1_H

#include "anaLib0.h" /* most probably this should be changed to a more generic way */
#include "xrp.h"

#ifdef KERNEL
#include <linux/string.h>
#endif


extern xrpSpecs_t defaultXrpSpecs;   /*  defines the default xrp specifics used by AL1 */
extern int initialized;

int anaL1_initDefault(void);

int anaL1_requestReply(const anaLabel_t label, void* msg, int len, anaCallback_t fct, void *aux, copyAuxFunction cpy, freeAuxFunction fr, int thread);

/* The requestReply function will send the given data,
   i.e. 'len' Bytes, to the given label.
   Beforehand and internally, a "return IDP" is created
   and bound to the indicated function fct. This function
   will receive an upcall once the result is ready.
   Returns 0 on success, a negative value otherwise.
*/
int anaL1_encResolve(xrpMsg_t msg, struct context_s *ctxt, struct service_s *srv, char chanType, struct service_s *queryingService);

int anaL1_encLookup(xrpMsg_t msg, struct context_s *ctxt, struct service_s *srv, struct service_s *queryingService);

int anaL1_encData(xrpMsg_t msg, void *data , int lenData,  struct context_s *senderContext, struct service_s *senderService, anaLabel_t responseLabel);
 
int anaL1_encCompartmentPublish(xrpMsg_t msg, const anaLabel_t idp, struct context_s *ctxt,  struct service_s *srv, int permanent);

int anaL1_encCompartmentUnpublish(xrpMsg_t msg, const anaLabel_t idp, struct context_s *ctxt, struct service_s *srv);

int anaL1_decResponse(xrpMsg_t replyMsg, xrpClass_t className, int occurence, void** ptPtVal);
/* This method parses a reply message 
   and returns the found value (to be selected by the class
   name of the argument). The ptPtVal points to a pointer that is allocated with the right size,
   where the wanted argument value copied into it.
   the returned int indicates how many Bytes were written into the
   val location.
   Returns a negative number on failure.
*/

xrpMsg_t anaL1_allocateMessage(void); 

int anaL1_isError(xrpMsg_t replyMsg); /* if ERROR command returns 1,  0 otherwise */

#endif /* _ANA_AL1_H */
