#ifndef __ANATHREAD__
#define __ANATHREAD__

/* initialize the anaThread environment */
void anaThreadInit(void);

/* cleanup the anaThread environment (wait until all threads have terminated) */
void anaThreadExit(void);

/* the public interface, i.e. anaThread(...) */
/* is defined in brick_template.h, to be linked with brick at compilation time */

/* the real anaThread function, for the minmex and API libraries */
unsigned long int _anaThread(anaHandle_t brickhandle, void* (*start_routine)(void *), void *arg, char *name);

/* to be called from a thread to determine whether it should stop */
int anaThreadShouldStop(void);

/* to kill all the threads for a given brick */
int anaThread_killbrick(anaHandle_t brickhandle); 

/* to set and get the ana_errno value for the calling thread */
int set_ana_errno(int value); /* returns -1 if thread is not found in anathead_list, 0 otherwise */
int get_ana_errno(void);      /* returns ana_errno_value, or ??? if thread not found ? */

#endif
