
#include "anaLib0.h"

int vlinkBind(anaLabel_t dest, anaLabel_t replyto, anaLabel_t dataRecv);
anaLabel_t vlinkBindResponse(void *msg, int len, anaLabel_t dataRecv, anaLabel_t *unbind, unsigned char *vl_mac);

int vlinkBind(anaLabel_t dest, anaLabel_t replyto, anaLabel_t dataRecv)
{
	int len;
	unsigned char *buf = NULL;
	
	if (!dest || !replyto || !dataRecv )
	{
		anaPrint(ANA_ERR, "vlinkBind: NULL arguments\n");
		return -1;
	}
	
	len = 2*sizeof(anaLabel_t) + sizeof(anaHandle_t);
	buf = (unsigned char *) malloc(len);
	
	if (!buf)
	{
		anaPrint(ANA_ERR, "vlinkBind --> cannot allocate buffer\n");
		return -1;
	}
	
	memcpy(buf, &replyto, sizeof(anaLabel_t));
	memcpy(buf + sizeof(anaLabel_t), &dataRecv, sizeof(anaLabel_t));
	memcpy(buf + 2*sizeof(anaLabel_t), &myHandle, sizeof(anaHandle_t));
	
	anaL0_send(dest, buf, len);
	free(buf);
	return len;
}


anaLabel_t vlinkBindResponse(void *msg, int len, anaLabel_t dataRecv, anaLabel_t *unbind, unsigned char *vl_mac)
{ 
	/* received format : [IDP to vlink][IDP to unbind][handle of vlink brick][vMAC address] */
	
	anaLabel_t res = 0;
	anaHandle_t vlHandle = 0;
	int exp_len = 2*sizeof(anaLabel_t) + sizeof(anaHandle_t);
	
	if ( !msg || !dataRecv )
	{
		anaPrint(ANA_ERR, "vlinkBindResponse: msg or datarecv IDP is NULL!\n");
		return 0;
	}
	
	if (len < exp_len)
	{
		anaPrint(ANA_ERR, "vlinkBindResponse: msg len too short! %d (should be %d)\n", len, exp_len);
		return 0;
	}

	memcpy(&res, msg, sizeof(anaLabel_t));
	memcpy(unbind, msg + sizeof(anaLabel_t), sizeof(anaLabel_t));
	memcpy(&vlHandle, msg + 2*sizeof(anaLabel_t), sizeof(anaHandle_t));

	if ( vl_mac && len >= (exp_len + 6) )
		memcpy(vl_mac, (unsigned char *)msg + exp_len, 6);
			 
	/* we change the view of the IDP */	
	if (anaL0_changeLabelView(dataRecv, 0, vlHandle) < 0)
	{
		anaPrint(ANA_ERR, "vlinkBindResponse: unable to change data recv IDP's viewer\n");
		return 0;
	}

	return res;
}

