#ifndef _ANAHASH_H
#define _ANAHASH_H



/***************************************************************

Hash functions by Bob Jenkins, December 1996, Public Domain.

2005-11-09: tested by CJ with 128-bit keys to 10 bits values 
            --> hash function has a uniform distribution

***************************************************************/

typedef  unsigned long  int  ub4;   /* unsigned 4-byte quantities */
typedef  unsigned       char ub1;

#define hashsize(n) ((ub4)1<<(n))
#define hashmask(n) (hashsize(n)-1)

#define mix(a,b,c) \
{ \
  a -= b; a -= c; a ^= (c>>13); \
  b -= c; b -= a; b ^= (a<<8); \
  c -= a; c -= b; c ^= (b>>13); \
  a -= b; a -= c; a ^= (c>>12);  \
  b -= c; b -= a; b ^= (a<<16); \
  c -= a; c -= b; c ^= (b>>5); \
  a -= b; a -= c; a ^= (c>>3);  \
  b -= c; b -= a; b ^= (a<<10); \
  c -= a; c -= b; c ^= (b>>15); \
}

ub4 hash( ub1 *k, ub4 length, ub4 initval, int maskLength);

#ifdef NS2
ub4 KVRhash( ub1 *k, ub4 length, ub4 initval, ub4 maskLength);
ub4 QREPhash( ub1 *k, ub4 length, ub4 initval, ub4 maskLength);
ub4 hashMQT( ub1 *k, ub4 length, ub4 initval, ub4 maskLength);
#endif

#endif
