#ifndef _ANANODE_DECL_H
#define _ANANODE_DECL_H

struct attachRes_s {
	anaHandle_t handle;
	anaLabel_t nodeCompLabel;
};


extern struct attachRes_s *handleAttach(char *brick_name, void *commAux);
extern void handleDetach(anaHandle_t handle, int exitVal);
extern void handleHBRequest(anaHandle_t handle);
extern int  handleRedirect(anaHandle_t querier, anaHandle_t originViewer, anaLabel_t originLabel, anaHandle_t destViewer, anaLabel_t destLabel );
extern int  handleForkData(anaHandle_t querier, anaHandle_t originViewer, anaLabel_t originLabel, anaHandle_t destViewer, anaLabel_t destLabel);
extern int  handleRegister (anaHandle_t querier, anaCallback_t fct, void *aux, copyAuxFunction copyAux, freeAuxFunction freeAux, anaHandle_t viewer, int perm, int thread, anaLabel_t *result);
extern int  handleChangeLabelAux (anaHandle_t querier, anaLabel_t label, void *newAux, copyAuxFunction copyAux, freeAuxFunction freeAux);
extern int  handleUnregister(anaHandle_t querier, anaHandle_t viewer, anaLabel_t label);
extern int  handleChangeView(anaHandle_t querier, anaHandle_t oldViewer, anaLabel_t label, anaHandle_t newViewer);
extern int  dispatchData(anaHandle_t querier, anaLabel_t label, anaHandle_t viewer, void *data, int len);

extern int  minmex_getIDPinfo(anaHandle_t querier, anaHandle_t viewer, anaLabel_t label, struct IDPinfo_s *toBeFilled);
extern int  minmex_setIDPinfo(anaHandle_t querier, struct IDPinfo_s *info);

extern int  minmex_unregisterEventHandler(anaHandle_t owner, struct anaEventSub_s* sub );
extern int  minmex_registerEventHandler(anaHandle_t callee, anaHandle_t owner, struct anaEventSub_s* sub, anaCallback_t notificationWrapper, void *aux, int auxLen, int threadFlag );
extern int  minmex_notifyEvent(anaHandle_t notifier, struct anaEventNotif_s *notif );

#endif /* _ANANODE_DECL_H */
