/* libipt_ip2ana.c
 * 
 * IP to ANA migration/adaptation layer
 * Shared object extension for the iptables command
 *
 * Author: Christophe Jelger <Christophe.Jelger@unibas.ch>
 * 	   	
 * Copyright (c) 2008, University of Basel
 *  
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <getopt.h>
#include <iptables.h>
#include <net/if.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <linux/netfilter_ipv4/ip_tables.h>

static struct option opts[] = {
	{ 0 }
};

static void help(void) 
{
	printf("ip2ana target v%s takes no argument", IPTABLES_VERSION);
}

static void save(const struct ipt_ip *ip,
		const struct ipt_entry_target *target)
{
	return;
}

static void print(const struct ipt_ip *ip,
		const struct ipt_entry_target *target, int numeric)
{
	printf("ip2ana");
}

/* Initialize the target. */
static void init(struct ipt_entry_target *t, unsigned int *nfcache)
{
	return;
}

static int parse(
		int c, 
		char **argv, 
		int invert, 
		unsigned int *flags, 
		const struct ipt_entry *entry, 
		struct ipt_entry_target **target)
{
	return 1;
}

static void final_check(unsigned int flags)
{
	return;
}

static struct iptables_target ip2ana = {
	.next           = NULL, 
	.name           = "ip2ana",
	.version        = IPTABLES_VERSION,
	.size           = 0,
	.userspacesize  = 0,
	.parse          = &parse,
	.help           = &help,
	.init           = &init,
	.final_check    = &final_check,
	.print          = &print,
	.save           = &save,
	.extra_opts     = opts 
};

void _init(void)
{
	register_target(&ip2ana);
}

