#ifndef _KVR_H
#define _KVR_H

#include "anaCommon.h"
#include "hashFunction.h"

extern int existsIDP(anaLabel_t label); /* checks in the IDT if label exists, returns 1 if exists, 0 otherwise */

struct KVRKeyword{
	char *keyWord;
	struct KVRKeyword *next;
};

struct KVREntry{
	char *name;
	anaLabel_t IDP;
	anaHandle_t owner;
	int age;
	struct KVRKeyword *keyWordsList;
	struct KVREntry *next; /* for hash conflict cases*/	
};

struct KVRKeyObjectList{
	struct KVREntry *entry;
	struct KVRKeyObjectList *next;
};

struct KVRKey{
	char *keyWord;
	struct KVRKeyObjectList *entriesList;
	struct KVRKey *next;   /* for hash conflict cases*/ 
};

/*the repository*/
struct KVR{
	int sizeEntryTab;
	int sizeKeyTab;
	int hashMaskEntry;
	int hashMaskKey;
	int deadEntryLimit;	
	struct KVREntry **entryTab;
	struct KVRKey **keyTab; 
};

enum{OPERATOR, OPERAND};

struct token{ 
	int type; /*indicates wether token is operand or operator*/	
	char *lexicalVal;
	void *semanticVal;
	struct token * prev; /* double chained list*/
	struct token * next;
};

#include "KVR_decl.h"

#endif
