#ifndef KVR_DECL_H_
#define KVR_DECL_H_


int initializeKVR(struct KVR *rep, int hashMaskEntryTab, int hashMaskKeyTab, int deadEntryLimit);

int name2hash(struct KVR *rep, char *name);

int key2hash(struct KVR *rep, char *key);

struct KVREntry *allocateKVREntry(char *name, anaLabel_t label, anaHandle_t owner);

int addKeywordToEntry(struct KVREntry *entry, char *keyWord);

int updateKey(struct KVR *rep, char *keyword, struct KVREntry *entry);

int freeKey(struct KVR *rep, struct KVRKey *key, int h);

int removeFromKeysList(struct KVR *rep, struct KVREntry *toRemove, char *keyword);

int freeKVREntry(struct KVR *rep, struct KVREntry *entry);

struct KVREntry *getKVREntryByName(struct KVR *rep, char *name);

int addKVREntry(struct KVR *rep, struct KVREntry *entry);

struct KVRKeyObjectList * findByKey(struct KVR *rep, char *key);

int checkKVREntries(struct KVR *rep);

int  removeKVREntry(struct KVR *rep, char *name, struct KVREntry *pointer);

void freeHandleKVREntries(struct KVR *rep, anaHandle_t owner);

/* parser functions*/
struct KVRKeyObjectList * getCopyObjList(char *keyword);
struct KVRKeyObjectList * intersectObjLists(struct KVRKeyObjectList *list1 , struct KVRKeyObjectList *list2);
struct KVRKeyObjectList * minusObjLists(struct KVRKeyObjectList *list1 , struct KVRKeyObjectList *list2);
struct KVRKeyObjectList * uniteObjLists(struct KVRKeyObjectList *list1 , struct KVRKeyObjectList *list2);

int evalQuery(char *buf , struct KVRKeyObjectList **res );
struct token * tokenize(char *expr);
int evalTokenChain(struct token *tkChain);
void displayTokenChain(struct token *tokenChain);
int reduceAND(struct token *tkChain);
int reduceORMINUS(struct token *tkChain);
int reduceParentheses(struct token *tkChain);
void freeToken(struct token *tk);

#endif /*KVR_DECL_H_*/
