
#ifndef _CLIENTTABLE_H
#define _CLIENTTABLE_H

#ifdef USER
#include <stdio.h>
#include <strings.h>
#include <stdlib.h>
#endif

#include "anaCommon.h"
#include "hashFunction.h"


struct BTentry_s {
	anaHandle_t handle;  /* key of the hash table, identifier of the brick */
	int age;	/* incremented at each heartBeatCheck timeout, set back to zero on reception of HB request from minmex */
	int nbPermanentEntries;
	int nbVolatileEntries;
	int pluginFlag;	
	char *brickName;	/* when the brick attach itself, it gives a name to be "humanly identifiable with" */	
	void *commAux; 		/* this field contains the structure with necessary info to send data to the brick */
	struct BTentry_s *next; /* in case of a hash conflict  */
};


typedef struct {
	unsigned int size;  /* size of the entries array */
	int hashMaskSize; /* size of the mask used in hash, is log2 of table size*/
	int nbBricks;  /* number of active entries in the table (in/de)cremented  at (at/de)tach */
	struct BTentry_s **tab;
} BrickTable_t;  /* hash table IDT type */

#include "clientTable_decl.h"

#endif /* _CLIENTTABLE_H */
 
