#ifndef _DISPATCHTABLE_H
#define _DISPATCHTABLE_H
#include "anaCommon.h"

#ifdef USER
#include <stdio.h>
#include <string.h>
#include <strings.h>
#include <stdlib.h>
#endif

#ifdef KERNEL
#include <linux/kernel.h>
#include <linux/stat.h>
#endif

#include "hashFunction.h"

typedef int (*minmexCallback_t)(void *data, int len, anaLabel_t input,void *aux, int auxLen);

struct IDTentry_s {
	anaLabel_t label;        		/* key of the hash table*/

	anaHandle_t viewer;			/*indicates the private viewer of
						   this entry. if NULL the entry is public	*/
	anaHandle_t owner; 			/* indicates the owner of the IDP */
	minmexCallback_t callBackFct; 		/* function handling the IDP */
	void *aux;				/* auxilary argument of the callback function  */
	int auxLen;
	int age;
	
	
	/*<indpinfo stuff>*/
	
	char ICflag; /* 1 for IC*/
	struct context_s destContext;
	struct service_s destService;
	uint16_t MTU;
	char chanType;
	anaLabel_t nextIDP;
	
	/*< /indpinfo stuff>*/
	
	
					/* incremented at each heratBeat */
	struct IDTentry_s *next;   		/* in case there is a hash conflict  */
};

typedef struct {
	unsigned int size;				/* length of the tab array  */
	int hashMaskSize;				/* is log2 of the array length */
	int deadEntryLimit;  				/* defines the number of heartBeat checks with no use of the entry => over this limit we delete the entry */
	struct IDTentry_s **tab;
} IDT_t;  

extern int sendNotification(anaHandle_t handle, void *msg, int len);

#include "dispatchTable_decl.h"

#endif
