#ifndef NODECOMP_DECL_H_
#define NODECOMP_DECL_H_


extern xrpSpecs_t defaultXrpSpecs;   /*  defines the default xrp specifics used by AL1 */
extern struct KVR kValRep;


extern int sendToIDP(void *msg, int len, anaLabel_t label);
extern int createIDP(minmexCallback_t callBackFct, anaLabel_t *labelp, void *aux, int auxLen, anaHandle_t owner , anaHandle_t viewer, int perm);

void dispatchNodeCompMsg(void *data, int len, anaLabel_t input, void *aux, int auxLen);

void sendMulticast(void *msg, int len, anaLabel_t input, void *query, int queryLen);

int initNodeComp(int hashMaskEntryTab, int hashMaskKeyTab, int deadKVREntryLimit); /*these arguments are used to initialize the KVR*/

void handleResolve(void *msg, int len, anaLabel_t input, void *aux, int auxLen);

void handleLookup(void *msg, int len, anaLabel_t input, void *aux, int auxLen);

void handlePublish(void *msg, int len, anaLabel_t input, void *aux, int auxLen);

void handleUnpublish(void *msg, int len, anaLabel_t input, void *aux, int auxLen);

void heartBeatNCCheck(void); /*this function is triggered at each heartBeat of the ana Node*/

#endif /*NODECOMP_DECL_H_*/
