#ifndef _NOTIFTABLE_H
#define _NOTIFTABLE_H
#include "anaCommon.h"


struct notifAux_s {
	anaHandle_t callee; 			/* indicates the owner of the IDP */
	anaHandle_t owner; 			/* the owner can be different from the callee in case of gates plugin */
	anaCallback_t callBackFct; 		/* function handling the IDP */
	uint32_t eventID;
	void *aux;				/* auxilary argument of the callback function  */
	int auxLen;
	int thread;
	struct notifAux_s *next;
};


struct notifEntry_s {

	void *eventKey; /* key to the hash table */
	int keyLen;
	struct notifAux_s *notifAux;
	struct notifEntry_s *next;
};


typedef struct {
	unsigned int size;				/* length of the tab array  */
	int hashMaskSize;				/* is log2 of the array length */
	struct  notifEntry_s**tab;
} notifTable_t;  




int initializeNotifTable(notifTable_t *Table, int hashMaskSize);
struct notifEntry_s* getNotifEntry(notifTable_t *Table, void *key,  int keyLen);
int freeNotifTable(notifTable_t *Table);
int freeNotifEntry(notifTable_t *Table, void *key, int keyLen);
int addNotifEntry (notifTable_t *Table, struct notifEntry_s *toAdd);
unsigned int notifkey2hash( notifTable_t *Table, void *key, int keyLen);
#endif
