#include "anaCommon.h"


/* data argument : - in user space mode, it's an int* 
		 pointing to the value of the descriptor
	- in kernel mode, it's a struct sockaddr **
	(2 stars !!) pointing to the pointer in anaMinmexSpecs  
		   */
void closeWrapper(void * sock){
	
	if(sock == NULL){
    		anaPrint(ANA_ERR, "closeWrapper : sock ==null\n");
        	return;
   	}
#ifdef USER
	anaPrint(ANA_DEBUG, "--- CloseWrapper call \n");
	close(*(int*)sock);
#endif
#ifdef KERNEL
	if(*((struct socket **)sock)){
      		sock_release(*((struct socket **)sock));
      		*((struct socket **)sock)  = NULL;
   	}
#endif
} 

int sockCreateWrapper(void *returnedSock, int domain, int type, int protocol){
#ifdef USER
	int *descPointer = (int *)returnedSock;
	int ret = socket(domain, type, protocol);
    if (ret < 0  || descPointer == NULL)
       	return -1;
	*descPointer = ret;	
       	return 0;
#endif
#ifdef KERNEL
	/* in case of kernel mode returnedSock is a pointer to a pointer (2 stars) to
		a struct socket
	 */
    struct socket *newsocket = NULL;
	if (sock_create( domain, type, protocol, &newsocket) < 0)
      	return -1;
    *((struct socket **)returnedSock) = newsocket;
	return 0;
#endif
}
