#! /bin/sh

#############################################################################
# create_referencefile = 1 -> a new referencefile is generated
# create_referencefile = 0 -> test output is compared against referencefile
############################################################################# 
create_referencefile=0
user=$1		#perform user space validation (derived from validation.sh script)
kernel=$2	#perform kernel space validation

userok=0;	#whether tests have failed or not
kernelok=0;

ok=0;

#$1 newly created file $2 reference file
user_validate () {
	## verify output ##
	## we need to cut the date in front of each message:
	#awk '{ print (substr($0,28)) }' $1 > test_ana/validOut/tmp
	if [ $create_referencefile == 0 ]; then
		cmp -s $1 $2
		if [ $? == 0 ]; then
		#	echo "Test output agrees with reference output"
			ok=1
		else
			echo "Test output differs from reference output"
			diff $1 $2
			ok=0
		fi
	else
		cp $1 $2
		ok=1
	fi #create_referencefile
	## remove current result file ##
	rm $1
	return
}


#########################
# user space validation #
#########################
if [ $user == 0 ]; then
#	echo "no user space validation"
	userok=1
else

##### Test IP Brick, purely node local test is not really helpful... #####
echo "validate Field Based Routing Brick in user space"
./bin/minmex  &> /dev/null &
sleep 1
./bin/mxconfig load brick $PWD/so/vlink.so > /dev/null
sleep 1
./bin/vlconfig create 1 > /dev/null
./bin/vlconfig add_if vlink1 lo > /dev/null
./bin/vlconfig up vlink1 > /dev/null
sleep 1
./bin/mxconfig load brick $PWD/so/eth-vl.so > /dev/null
sleep 1
./bin/mxconfig load brick $PWD/so/fbr_diss.so > /dev/null
sleep 1
./bin/mxconfig load brick $PWD/so/fbr_forw.so > /dev/null
sleep 1
./bin/mxconfig load brick $PWD/so/fbr_ftab.so > /dev/null
sleep 1
./bin/mxconfig load brick $PWD/so/fbr_rtab.so > /dev/null
sleep 1
./bin/mxconfig load brick $PWD/so/fbr_potf.so > /dev/null
sleep 1
./bin/mxconfig load brick $PWD/so/fbr_serv.so D=ANA_VALIDATE > /dev/null
sleep 3
./bin/mxconfig load brick $PWD/so/fbr_clie.so > /dev/null


## wait until test has finished ##
sleep 5

## kill all bricks ##
killall -s SIGINT minmex

## verify output ##
ok=0
user_validate test_ana/validOut/fbr test_ana/referenceData/referencedata_fbr.txt
userok=$ok

#ok=0
#user_validate test_ana/validOut/ip_config test_ana/referenceData/referencedata_ip_config.txt
#if [ $userok == 1 ] && [ $ok == 1 ]; then
#	userok=1
#else
#	userok=0
#fi


fi #user


###########################
# kernel space validation #
###########################
if [ $kernel == 0 ]; then
#	echo "no kernel space validation"
	kernelok=1
else
	##### ip #####
	echo "FBR is not yet tested in kernel space"
	kernelok=1

fi

###########################
#     check validation    #
###########################
if [ $userok == 0 -o $kernelok == 0 ]; then
	echo "there was an errror during validation of the FBR Brick"
	exit 1
else
	echo "validation of FBR successful"
	exit 0
fi

