#! /bin/sh

#############################################################################
# create_referencefile = 1 -> a new referencefile is generated
# create_referencefile = 0 -> test output is compared against referencefile
############################################################################# 
create_referencefile=0
user=$1		#perform user space validation (derived from validation.sh script)
kernel=$2	#perform kernel space validation

userok=0;	#whether tests have failed or not
kernelok=0;

ok=0;	
#$1 newly created file $2 reference file
user_validate () {
	## verify output ##
	## we need to cut the date in front of each message:
	#awk '{ print (substr($0,28)) }' $1 > test_ana/validOut/tmp
	if [ $create_referencefile == 0 ]; then
		cmp -s $1 $2
		if [ $? == 0 ]; then
		#	echo "Test output agrees with reference output"
			ok=1
		else
			echo "Test output differs from reference output"
			diff $1 $2
			ok=0
		fi
	else
		cp $1 $2
		ok=1
	fi #create_referencefile
	## remove current result file ##
	rm $1
	return
}


#########################
# user space validation #
#########################
if [ $user == 0 ]; then
#	echo "no user space validation"
	userok=1
else
#####   Test the vlink  #####
echo "validate user mode misc template brick"
## start Bricks ##
./bin/minmex &> /dev/null &
sleep 1
./bin/mxconfig load brick $PWD/so/brick_template_misc.so D=ANA_VALIDATE arg1 arg2 arg3 > /dev/null
## wait until test has finished ##
sleep 8 

## kill all bricks ##
killall -s SIGINT minmex

## verify output ##
ok=0
user_validate test_ana/validOut/brick_misc test_ana/referenceData/referencedata_brick_misc.txt
userok=$ok
fi


###########################
# kernel space validation #
###########################
if [ $kernel == 0 ]; then
#	echo "no kernel space validation"
	kernelok=1
else
#####   Test the vlink  #####
echo "validate kernel misc template brick"
## start Bricks ##
insmod modules/anaControl.ko
insmod modules/anaMinmex.ko
insmod modules/anaBrick_misc.ko D=ANA_VALIDATE a=arg1,arg2,arg3

## wait until test has finished ##
sleep 8

## verify output ##
ok=0
cp /proc/brick_misc/brick_misc test_ana/validOut/brick_misc
user_validate test_ana/validOut/brick_misc test_ana/referenceData/referencedata_brick_misc.txt
kernelok=$ok

##remove the bricks
rmmod anaBrick_misc
rmmod anaMinmex
rmmod anaControl
if [ $? != 0 ]; then
kernelok=0
fi

fi

###########################
#     check validation    #
###########################
if [ $userok == 0 -o $kernelok == 0 ]; then
	echo "there was an errror during validation of the misc template brick"
	exit 1
else
	echo "validation of misc template brick successful"
	exit 0
fi

