#! /bin/sh

#the top level validation file.
#before committing any code this shell script has to return with no error!

# set the tests to be executed #
# warning: all tests have to pass before you commit! #
compilation=1	# do the initial compilation #
user=1		# user space validation
kernel=1 	# kernel space validation

#####################
# do not edit below #
#####################

if [ $# -lt 1 ]; then
        echo 1>&2 Usage: $0 all or $0 script to be executed
        exit 127
fi


if [ $1 == all ]; then
	files=./test_ana/script*.sh
else
	files=$1
fi

echo "The following scripts will be executed:"
for filename in $files #./test_ana/script*.sh
do
	echo " `basename $filename`"
done


userok=0;
kernelok=0;

#########################
#   check compilation   #
#########################

if [ $compilation == 1 ]; then
make clean
make
if [ $? == 0 ]; then
	echo "***************************************"
	echo "compilation tests successful"
	echo "***************************************"
else
	echo "#######################################"
	echo "compilation tests failed"
	echo "#######################################"
	exit 1
fi

fi #compilation


#########################
#     check Bricks      #
#########################
testfailed=0
for file in $files #./test_ana/script*.sh
do
	$file $user $kernel
	if [ $? != 0 ]; then
		echo "test failure: "$file
		testfailed=`expr $testfailed + 1`
		echo " "
	else
		echo "test ok "$file
		echo " "
	fi
done
if [ $testfailed != 0 ]; then
	echo "################################################################"
	echo "----> validation failed: number of failed tests: "$testfailed
	echo "################################################################"
	exit 1
else
	echo "******************************"
	echo "----> validation successful"
	echo "******************************"
fi

echo "*************************************** "
echo "brick verification tests successful"
echo "you can commit your changes to the svn"
echo "*************************************** "
exit 0
fi
